<?php

function wpv_admin_archive_listing_name() {
    ?>
        <table id="wpv_view_list" class="js-wpv-views-listing wpv-views-listing wpv-views-listing-by-name widefat">
            <thead>
                <tr>
                    <th><?php _e('Title','wpv-views') ?></th>
                    <th><?php _e('Archive usage','wpv-views') ?></th>
                    <th><?php _e('Action','wpv-views') ?></th>
                </tr>
            </thead>
            <tfoot>
                <tr>
                    <th><?php _e('Title','wpv-views') ?></th>
                    <th><?php _e('Archive usage','wpv-views') ?></th>
                    <th><?php _e('Action','wpv-views') ?></th>
                </tr>
            </tfoot>

            <tbody class="js-wpv-views-listing-body">
                <?php
                /*$query = new WP_Query('post_type=view');
                while ($query->have_posts()) :
                        $query->the_post();

                        $meta = get_post_meta(get_the_id(), '_wpv_settings');

                        //  var_dump($meta[0]["view-query-mode"]);

                        if ($meta[0]["view-query-mode"] == "archive") {
                                echo wpv_admin_menu_archive_listing_row(get_the_id());
                        }
                endwhile;*/
                echo wpv_admin_menu_views_listing('archive');
            ?>
            </tbody>
        </table>
    <?php
}

function wpv_admin_archive_listing_usage() {
    ?>
        <table id="wpv_view_list_usage" class="js-wpv-views-listing wpv-views-listing wpv-views-listing-by-usage widefat">

            <thead>
                <tr>
                    <th class="js-wpv-col-one"><?php _e('Used for','wpv-views') ?></th>
                    <th class="js-wpv-col-two"><?php _e('Title','wpv-views') ?></th>
                    <th><?php _e('Action','wpv-views') ?></th>
                </tr>
            </thead>
            <tfoot>
                <tr>
                    <th class="js-wpv-col-one"><?php _e('Used for','wpv-views') ?></th>
                    <th class="js-wpv-col-two"><?php _e('Title','wpv-views') ?></th>
                    <th><?php _e('Action','wpv-views') ?></th>
                </tr>
            </tfoot>

            <tbody class="js-wpv-views-listing-body">

                <?php
                    global $WPV_view_archive_loop;
                    global $WP_Views;

                    $options = $WP_Views->get_options();

                    $loops = $WPV_view_archive_loop->_get_post_type_loops();

                    $pt = get_post_types();

                    $usage_list = array();
                    $taxonomies = get_taxonomies('', 'objects');
                    foreach ($taxonomies as $category_slug => $category){
			if ( in_array($category_slug, array('post_format','link_category','nav_menu')) ) {
				continue;
			}
			if ( !$category->show_ui ) {
				continue; // Only show taxonomies with show_ui set to TRUE
			}
                        $name = $category->name;
                        $usage_list['view_taxonomy_loop_'.$name] = $category->labels->name;
                    };
                    foreach ($loops as $slug => $name){
                        $usage_list['view_'.$slug] = $name;
                    }

                    foreach ($options as $slug => $name){
                        if (preg_match('/^views_template_for_(.*)/', $slug))
                            $usage_list[$slug] = $name;
                    }

                    //var_dump($usage_list);
                    foreach ($usage_list as $key => $value) {

                        //Juan please review this code. This part hide custom post types. Commented.
                        /*if (preg_match('/^view_cpt_(.*)/', $key, $out)) {
                                continue;
                        }*/

                        $loop_name = '';
                        $post = null;
                        if (isset($options[$key])) {

                            $post = get_post($options[$key]);

                            // taxonomy
                            if (preg_match('/^view_taxonomy_loop_(.*)/', $key, $out)) {
                                $args=array(
                                'name' => $out[1]
                                );
                                $taxonomy=get_taxonomies($args, 'objects');
                                $loop_name = $taxonomy[$out[1]]->labels->singular_name;
                            } elseif (preg_match('/^views_template_for_(.*)/', $key, $out)) {

                                $pt = get_post_type_object( $out[1] );
                                $loop_name = $pt->labels->singular_name;

                            // loop
                            }
                            elseif (preg_match('/^view_(.*)/', $key, $out)) {
                                $loop_name = $loops[$out[1]];
                            }
                        } else {
                            $loop_name = $value;
                        }
                    ?>

                    <tr class="js-wpv-view-list-row">
                    <td>
                        <h3 class="row-title"><?php echo $loop_name ?></h3>
                    </td>
                    <?php if (is_null($post)): ?>
                        <td colspan="3">
                            <a class="button js-create-view-for-archive" href="<?php get_admin_url(); ?>admin.php?page=view-archives-new"><i class="icon-plus"></i><?php _e('Create a View for this archive');?></a>
                        </td>
                    <?php else: ?>
                    <td>
                        <a href="admin.php?page=view-archives-editor&view_id=<?php echo $post->ID?>"><?php echo $post->post_title; ?></a>
                    </td>

                    <td>
                        <select class="js-list-views-usage-action" name="list_views_usage_action_<?php echo $post->ID; ?>" id="list_views_usage_action_<?php echo $post->ID; ?>" data-view-id="<?php echo $key; ?>">
                            <option value="0"><?php _e('Choose','wpv-views') ?>&hellip;</option>
                            <option value="change_usage"><?php _e('Change','wpv-views') ?></option>
                        </select>
                    </td>

                    <!--<td>
                            <button class="button js-add-new-content-template" data-id="<?php echo $post->ID; ?>"><i class="icon-exchange"></i>  <?php _e('Change','wp-views') ?></button>
                    </td>-->
                    <?php endif; ?>
                    </tr>
                <?php }

                ?>
            </tbody>
        </table>
        <?php
}

function wpv_admin_archive_listing_page($type='name') {
    global $WPV_view_archive_loop;
	?>
	<div class="wrap toolset-views">

        <div class="wpv-views-listing-page wpv-views-listing-archive-page" data-none-message="<?php _e("This View isn't being used for any archive loops.",'wpv-views') ?>">

        	<div id="icon-views" class="icon32"></div>
            <?php $has_items = wpv_check_items_exists('archive'); ?>
        	<h2 class="wpv-page-title">
        		<?php _e('WordPress Archives', 'wpv-views') ?>
        		<a href="#" data-target="<?php echo admin_url('admin-ajax.php');?>?action=wpv_show_view_loop" class="add-new-h2 js-wpv-views-archive-add-new wpv-views-archive-add-new" style="<?php if ( !$has_items || !$WPV_view_archive_loop->check_archive_loops_exists() ) echo 'display:none'; ?>" >
                    <?php _e('Add new WordPress Archive','wpv-views') ?>
                </a>
        	</h2>

            <?php
            wp_nonce_field( 'work_views_listing', 'work_views_listing' );
            ?>
        	<form id="posts-filter" action="" method="get" class="<?php if ( !$has_items || !$WPV_view_archive_loop->check_archive_loops_exists() ) echo 'hidden'; ?>">
        		<p class="search-box">
        			<label class="screen-reader-text" for="post-search-input">Search Views:</label>
        			<input type="search" id="post-search-input" name="s" value="">
        			<input type="submit" name="" id="search-submit" class="button" value="Search Views">
        		</p>
        	</form>

            <p id="js-wpv-no-archive" class="toolset-alert toolset-alert-info <?php if ( $WPV_view_archive_loop->check_archive_loops_exists() ) echo 'hidden'; ?>">
                <?php _e('All loops have a View assigned','wpv-views'); ?>
            </p>

        	<div class="wpv-views-listing-arrange js-wpv-views-listing-arrange <?php if ( !$has_items ) echo 'hidden'; ?>">
                <p><?php _e('Arrange by','wpv-views'); ?>: </p>
                <ul>
                    <li data-sortby="name" class="active"><?php _e('Name','wpv-views') ?></li>
                    <li data-sortby="usage"><?php _e('Usage','wpv-views') ?></li>
                </ul>
        	</div>

            <div id="js-wpv-archive-tables-containter" class="wpv-archive-tables-containter <?php if ( !$has_items ) echo 'hidden'; ?>">
                <?php wpv_admin_archive_listing_name(); ?>
            </div>

        	<p class="add-new-view js-add-new-view <?php if ( !$has_items || !$WPV_view_archive_loop->check_archive_loops_exists() ) echo 'hidden'; ?>">
                <a class="button js-wpv-views-archive-add-new wpv-views-archive-add-new" data-target="<?php echo admin_url('admin-ajax.php');?>?action=wpv_show_view_loop" href="admin.php?page=view-archives-new">
                    <i class="icon-plus"></i><?php _e('Add new WordPress Archive','wpv-views') ?>
                </a>
          	</p>

            <div class="wpv-view-not-exist js-wpv-view-not-exist <?php if ( $has_items ) echo 'hidden'; ?>">
                <p><?php _e('WordPress Archives let you customize the output of standard Archive pages.');?></p>
                <p>
                    <a class="button js-wpv-views-archive-create-new" data-target="<?php echo admin_url('admin-ajax.php');?>?action=wpv_show_view_loop" href="<?php get_admin_url(); ?>admin.php?page=view-archives-new">
                        <i class="icon-plus"></i>
                        <?php _e('Create your first WordPress Archive');?>
                    </a>
                </p>
            </div>

        </div> <!-- .wpv-settings-container" -->

        <div class="js-table-loader-overlay table-loader-overlay">
        	<p><?php _e('Loading','wpv-views') ?>&hellip;</p>
        </div>

	</div>
<?php

}

function wpv_admin_menu_archive_listing_row($post_id) {
	global $WPV_view_archive_loop;

	ob_start();
	$post = get_post($post_id);
	$meta = get_post_meta($post_id, '_wpv_settings');
	$view_description = get_post_meta($post_id, '_wpv_description', true);
	?>
	<tr id="wpv_view_list_row_<?php echo $post->ID; ?>" class="js-wpv-view-list-row" >
		<td>
    		<h3 class="row-title">
                <?php $post->post_title; ?>
    			<a href="admin.php?page=view-archives-editor&amp;view_id=<?php echo $post->ID; ?>"><?php echo trim($post->post_title); ?></a>
    		</h3>
    		<?php if (isset($view_description) && '' != $view_description): ?>
                <p class="desc">
                    <?php echo nl2br($view_description)?>
                </p>
            <?php endif; ?>
        </td>
		<td>
			<ul class="js-list-views-loops">
			<?php
			global $WP_Views;
			$options = $WP_Views->get_options();

			$loops = $WPV_view_archive_loop->_get_post_type_loops();

			$opt2 = $WPV_view_archive_loop->_view_edit_options($post->ID, $options);

			$selected = '';
			foreach ($loops as $loop => $loop_name) {
				if (isset($options['view_' . $loop]) && $options['view_' . $loop] == $post->ID) {
					$selected .= sprintf(__('<li>%s</li>', 'wpv-views'), $loop_name);
				}
			}
			$taxonomies = get_taxonomies('', 'objects');
			foreach ($taxonomies as $category_slug => $category) {

				if ( in_array($category_slug, array('post_format','link_category','nav_menu')) ) {
					continue;
				}
				if ( !$category->show_ui ) {
					continue; // Only show taxonomies with show_ui set to TRUE
				}

				$name = $category->name;

				if (isset ($options['view_taxonomy_loop_' . $name ]) && $options['view_taxonomy_loop_' . $name ] == $post->ID) {
					$selected .= sprintf(__('<li>%s</li>', 'wpv-views'), $category->labels->name);
				}
			}
			if (!empty($selected)) {
				echo $selected;
			} else {
				echo __("This View isn't being used for any archive loops.",'wpv-views');
			}
			?>
			</ul>
		</td>
		<td>
			<select class="js-list-views-action" name="list_views_action_<?php echo $post->ID; ?>" id="list_views_action_<?php echo $post->ID; ?>" data-view-id="<?php echo $post->ID; ?>">
				<option value="0"><?php _e('Choose','wpv-views') ?>&hellip;</option>
                    <option value="change"><?php _e('Change archive usage','wpv-views') ?></option>
				<option value="delete"><?php _e('Delete','wpv-views') ?></option>
			</select>
		</td>
		<!--<td>
			<button class="button js-change-button" data-id="<?php echo $post->ID; ?>"><i class="icon-exchange"></i>  <?php _e('Change','wp-views') ?></button>
		</td>-->
	</tr>

	<?php
	$row = ob_get_contents();
	ob_end_clean();

	return $row;
}