<?php

function wpv_admin_menu_content_templates_listing_page() {
	wp_nonce_field( 'work_view_template', 'work_view_template' );
	$query = new WP_Query('post_type=view-template&orderby=title&order=ASC');
	$count_posts = $query->post_count;
	?>
	<div class="wrap toolset-views">
		<div class="wpv-views-listing-page">

			<div id="icon-views" class="icon32"></div>
			<h2 class="wpv-page-title">
				<?php _e('Content Templates', 'wpv-views') ?>
			</h2>

			<?php if ($count_posts !== 0): ?>
				<input type="hidden" value="name" id="wpv-ct-current-sort">
				<form id="posts-filter" action="" method="get">
				   <p class="search-box">
					   <label class="screen-reader-text" for="post-search-input"><?php _e('Search Views:', 'wpv-views') ?></label>
					   <input type="search" id="ct-post-search-input" name="s" value="">
					   <input type="submit" name="" id="ct-search-submit" class="button" value="<?php echo htmlentities( __('Search Content Templates', 'wpv-views'), ENT_QUOTES ); ?>">
				   </p>
			   </form>
		   <?php endif; ?>

	   <?php if ($count_posts == 0) { //When no posts found ?>
			<p class="wpv-view-not-exist">
			  <?php _e('Content Templates let you design single pages.','wpv-views'); ?>
			</p>
	   <?php } else { ?>

		   <div class="wpv-views-listing-arrange">
				<p><?php _e('Arrange by','wpv-views'); ?>: </p>
				<ul>
					<li data-sortby="name" class="active"><?php _e('Name','wpv-views') ?></li>
					<li data-sortby="usage-single"><?php _e('Usage for single page','wpv-views') ?></li>
					<li data-sortby="usage-post-archives"><?php _e('Usage for custom post archives','wpv-views') ?></li>
					<li data-sortby="usage-taxonomy-archives"><?php _e('Usage for taxonomy archives','wpv-views') ?></li>
				</ul>
			</div>

		   <table class="wpv-views-listing widefat">

			<!-- section for: sort by name -->
				<thead>
					<tr>
						<th class="js-wpv-col-one"><?php _e('Title','wpv-views') ?></th>
						<th class="js-wpv-col-two"><?php _e('Used on','wpv-views') ?></th>
						<th><?php _e('Action','wpv-views') ?></th>
					</tr>
				</thead>
				<tfoot>
					<tr>
						<th class="js-wpv-col-one"><?php _e('Title','wpv-views') ?></th>
						<th class="js-wpv-col-two"><?php _e('Used on','wpv-views') ?></th>
						<th><?php _e('Action','wpv-views') ?></th>
					</tr>
				</tfoot>
				<!-- / section for: sort by name -->

				<tbody class="js-wpv-views-listing-body">
					<?php

					while ($query->have_posts()) :
					   $query->the_post();
					   $meta = get_post_meta(get_the_id(), '_wpv_settings');
					   echo wpv_admin_menu_content_template_listing_row( get_the_id() );
					endwhile;
					?>
			   </tbody>
		   </table>
		   <?php }?>
		   <p class="add-new-view">
			   <button class="button js-add-new-content-template"
			   data-target="<?php echo admin_url('admin-ajax.php')?>?action=wpv_ct_create_new">
				   <i class="icon-plus"></i><?php _e('Add new Content Template','wpv-views') ?>
			   </button>
		   </p>

			<?php if ( $count_posts != 0 ): ?>
			<div class="wpv-listing-pagination">

				<?php
					echo wpv_admin_menu_views_pager('0',1,'ct');
				?>
			</div> <!-- .wpv-listing-pagination -->
			<?php endif; ?>

		</div> <!-- .wpv-settings-container" -->

		<div class="js-table-loader-overlay table-loader-overlay">
			<p><?php _e('Loading','wpv-views') ?>&hellip;</p>
		</div>

		<?php
			// TODO: The script below should be moved to the separate file and maybe use another localiation method
			// TODO: Add strings to wp_localize_script
		?>
		<script type="text/javascript">
			jQuery(function($) {

				WpvPagination.ajaxData = { // set data object for AJAX request
					action: 'ct_change_view',
					view: 'name',
					wpnonce : jQuery('#work_view_template').attr('value')
				};


			 });

			 var wpv_close = '<?php echo esc_js( __('Close','wpv-views') ); ?>';
			 var wpv_title = '<?php echo esc_js( __('Title','wpv-views') ); ?>';
			 var wpv_used_on = '<?php echo esc_js( __('Used on','wpv-views') ); ?>';
			 var wpv_ct_msg1 = '<?php echo esc_js( __('Content Template was successfully updated','wpv-views') ); ?>';
			 var wpv_ct_msg6 = '<p><?php echo esc_js( __('Content Templates let you design single pages.','wpv-views') ); ?></p>';
		</script>

		<div class="popup-window-container">

			<div class="wpv-dialog js-remove-content-template-dialog">
				<div class="wpv-dialog-header">
					<h2><?php _e('Delete Content Template','wpv-views'); ?></h2>
				</div>
				<div class="wpv-dialog-content">
					<p><?php _e('Are you sure want delete this Content Template?','wpv-views'); ?></p>
				</div>
				<div class="wpv-dialog-footer">
					<button class="button js-dialog-close"><?php _e('Cancel','wpv-views'); ?></button>
					<button class="button button-primary js-remove-template-permanent"><?php _e('Delete','wpv-views'); ?></button>
				</div>
			</div>

			<div class="wpv-dialog js-duplicate-ct-dialog">
				<div class="wpv-dialog-header">
					<h2><?php _e('Duplicate Content Template','wpv-views') ?></h2>
				</div>
				<div class="wpv-dialog-content">
	                <p>
	                    <label for="duplicated_ct_name"><?php _e('Name this Content Template','wpv-views'); ?></label>
	                    <input type="text" value="" class="js-duplicated-ct-name" placeholder="<?php _e('Enter name here','wpv-views') ?>" name="duplicated_ct_name">
	                </p>
	                <div class="js-ct-duplicate-error"></div>
				</div>
				<div class="wpv-dialog-footer">
					<button class="button js-dialog-close"><?php _e('Cancel','wpv-views') ?></button>
					<button class="button button-secondary js-duplicate-ct" disabled><?php _e('Duplicate','wpv-views') ?></button>
				</div>
			</div> <!-- .js-duplicate-view-dialog -->

		</div>

	</div>
<?php }

function wpv_admin_menu_content_template_listing_row( $post_id ) {

	ob_start();
	$post = get_post($post_id);
	$wpv_content_template_decription  = get_post_meta($post->ID, '_wpv-content-template-decription', true);
	?>
	<tr id="wpv_ct_list_row_<?php echo $post->ID; ?>" class="js-wpv-ct-list-row">

		<td class="post-title page-title column-title">
			<h3 class="row-title">
				<a href="post.php?post=<?php echo $post->ID; ?>&amp;action=edit"><?php echo $post->post_title; ?></a>
			</h3>
			<?php if ( !empty($wpv_content_template_decription) ): ?>
				<p class="desc">
					<?php echo nl2br($wpv_content_template_decription)?>
				</p>
			<?php endif; ?>
		</td>
		<td>
			<p><?php echo wpv_content_template_used_for_list( $post->ID );?></p>
		</td>
		<td>
			<select class="js-list-ct-action" name="list_ct_action_<?php echo $post->ID; ?>" id="list_ct_action_<?php echo $post->ID; ?>"
				data-ct-id="<?php echo $post->ID; ?>" data-ct-name="<?php echo htmlentities( $post->title, ENT_QUOTES ); ?>">
				<option value="0"><?php _e('Choose','wpv-views') ?>&hellip;</option>
				<option value="change"><?php _e('Change usage','wpv-views') ?></option>
				<option value="duplicate" data-msg="<?php echo htmlentities( __('Enter new title','wpv-views'), ENT_QUOTES ); ?>"><?php _e('Duplicate','wpv-views') ?></option>
				<option value="delete"><?php _e('Delete','wpv-views') ?></option>
			</select>
		</td>
	</tr>

	<?php
	$row = ob_get_contents();
	ob_end_clean();

	return $row;

}

function wpv_content_template_used_for_list( $ct_id ){
	global $WP_Views, $wpdb;
	$list = '';
	$show_single = $show_loop = $show_tax = 0;
	$options = $WP_Views->get_options();
	$post_types_array = wpv_get_pt_tax_array();

	for ($i=0;$i<count($post_types_array['single_post']);$i++){
		$type = $post_types_array['single_post'][$i][0];
		$label = $post_types_array['single_post'][$i][1];
		if ( isset($options['views_template_for_' . $type]) && $options['views_template_for_' . $type] == $ct_id)   {

		$list .= $label;
				$posts = $wpdb->get_col( "SELECT {$wpdb->posts}.ID FROM {$wpdb->posts} WHERE post_type='{$type}'" );
				$count = sizeof( $posts );
				if ( $count > 0 ) {
					$posts = "'" . implode( "','", $posts ) . "'";
					$set_count = $wpdb->get_var( "SELECT COUNT(post_id) FROM {$wpdb->postmeta} WHERE
					meta_key='_views_template' AND meta_value!='{$options['views_template_for_' . $type]}'
					AND post_id IN ({$posts})" );
					if ( $set_count > 0){
					  $list .= '<a class="icon-warning-sign js-apply-for-all-posts js-alret-icon-hide-'.$type.'"
					  data-target="'.admin_url('admin-ajax.php').'?action=wpv_ct_update_posts&type='.$type.'&tid='.$ct_id.'"></a>';
					}
				}
		$list .= ', ';
		}
	}

	for ($i=0;$i<count($post_types_array['archive_post']);$i++){
		$type = $post_types_array['archive_post'][$i][0];
		$label = $post_types_array['archive_post'][$i][1];
		if ( isset($options['views_template_archive_for_' . $type]) && $options['views_template_archive_for_' . $type] == $ct_id)   {
			$list .= $label . ' Archive, ';
		 }
	}

	for ($i=0;$i<count($post_types_array['taxonomy_post']);$i++){
		$type = $post_types_array['taxonomy_post'][$i][0];
		$label = $post_types_array['taxonomy_post'][$i][1];
		if ( isset($options['views_template_loop_' . $type]) && $options['views_template_loop_' . $type] == $ct_id)   {
			$list .= $label . ' Taxonomy, ';
		 }
	}
	if ( !empty($list) ){
		$list = substr($list, 0, -2);
	}
	else{
	   $list = __('No Post types/Taxonomies assigned','wpv-views');
	}
	return $list;
}

function wpv_get_pt_tax_array(){
   static $post_types_array;
   static $taxonomies_array;
   static $wpv_posts_array;
   if ( !is_array($post_types_array) ){
	   $post_types = get_post_types( array('public' => true), 'objects' );
   }
   if ( !is_array($taxonomies_array) ){
	   $taxonomies = get_taxonomies( '', 'objects' );
   }

   if ( is_array($wpv_posts_array) ){
	   return $wpv_posts_array;
   }

   foreach ( $post_types as $post_type ) {
	   $wpv_posts_array['single_post'][] = array( $post_type->name, $post_type->label );
	   $wpv_posts_array['archive_post'][] = array( $post_type->name, $post_type->label );
   }

   foreach ( $taxonomies as $category_slug => $category ) {
	   if ( $category_slug == 'nav_menu' || $category_slug == 'link_category'
					|| $category_slug == 'post_format' ) {
				continue;
	   }
	   if ( !$category->show_ui ) {
			continue; // Only show taxonomies with show_ui set to TRUE
		}
		$wpv_posts_array['taxonomy_post'][] = array( $category->name, $category->labels->name );
   }

   return $wpv_posts_array;
}

function wpv_admin_menu_content_template_listing_by_type_row( $sort, $page = 0){
	global $WP_Views, $post, $wpdb;
	$options = $WP_Views->get_options();
	$post_types = get_post_types( array('public' => true), 'objects' );
	$post_types_array = wpv_get_pt_tax_array();
	ob_start();
	if ( $sort == 'usage-single' ){
		for ($i=0;$i<count($post_types_array['single_post']);$i++){
			$type = $post_types_array['single_post'][$i][0];
			$label = $post_types_array['single_post'][$i][1];


		?>

			<tr id="wpv_ct_list_row_<?php echo $type; ?>" class="js-wpv-ct-list-row">
				<td class="post-title page-title column-title">
					<h3 class="row-title">
						<?php echo $label;?>
					</h3>
				</td>
				<td>
					<ul>
						<?php
						$add_button = '<a class="button" data-disabled="1"
						href="post-new.php?post_type=view-template&action=wpv_ct_create_new&post_title='. urlencode(__('Content template for ','wpv-views'). $label ) .'&ct_selected=views_template_for_' . $type.'&toggle=1,0,0">
						<i class="icon-plus"></i>'. __('Add a new Content Template for this post type','wpv-views').'</a>';

						if ( isset($options['views_template_for_' . $type] ) && $options['views_template_for_' . $type] != 0)   {
							$post = get_post( $options['views_template_for_' . $type] );
							if ( is_object($post) ){
								?>
								<a href="post.php?post=<?php echo $post->ID;?>&action=edit"><?php echo $post->post_title;?></a>
								<?php
								$posts = $wpdb->get_col( "SELECT {$wpdb->posts}.ID FROM {$wpdb->posts} WHERE post_type='{$type}'" );
								$count = sizeof( $posts );
								if ( $count > 0 ) {
									$posts = "'" . implode( "','", $posts ) . "'";
									$set_count = $wpdb->get_var( "SELECT COUNT(post_id) FROM {$wpdb->postmeta} WHERE
									meta_key='_views_template' AND meta_value!='{$options['views_template_for_' . $type]}'
									AND post_id IN ({$posts})" );
									if ( $set_count > 0){
									 echo ' <span class="js-alret-icon-hide-'.$type.'"><a class="icon-warning-sign js-apply-for-all-posts"
									  data-target="'.admin_url('admin-ajax.php').'?action=wpv_ct_update_posts&type='.$type.'&tid='.$post->ID.'"></a> '. $set_count .' '. $label .' use a different template '.
									  '<a class="js-apply-for-all-posts" href=""
									  data-target="'.admin_url('admin-ajax.php').'?action=wpv_ct_update_posts&type='.$type.'&tid='.$post->ID.'">Update now</a></span>';
									}
								}

							}
							else{
								echo $add_button;
							}
						}
						else{
						   echo $add_button;
						}
						?>
					</ul>
				</td>
				<td>
					<select class="js-list-ct-action">
						<option value="0"><?php _e('Choose','wpv-views') ?>&hellip;</option>
						<option value="change_pt" data-msg="1" data-sort="<?php echo $sort;?>" data-pt="<?php echo 'views_template_for_' . $type;?>"><?php _e('Change Content Template','wpv-views') ?></option>
					</select>
				</td>

			</tr>
	<?php

		}
	}
	?>
  <?php
	if ( $sort == 'usage-post-archives' ){

		 for ($i=0;$i<count($post_types_array['archive_post']);$i++){
			$type = $post_types_array['archive_post'][$i][0];
			$label = $post_types_array['archive_post'][$i][1];
			 $add_button = '<a class="button" data-disabled="1"
						href="post-new.php?post_type=view-template&action=wpv_ct_create_new&post_title='. urlencode(__('Content template for ','wpv-views'). $label ) .'&ct_selected=views_template_archive_for_' . $type.'&toggle=0,1,0">
						<i class="icon-plus"></i>'. __('Add a new Content Template for this post type','wpv-views').'</a>';
		?>

			<tr id="wpv_ct_list_row_<?php echo $type; ?>" class="js-wpv-ct-list-row">
				<td class="post-title page-title column-title">
					<h3 class="row-title">
						<?php echo $label;?>
					</h3>
				</td>
				<td>
					<ul>
						<?php
						if ( isset($options['views_template_archive_for_' . $type] ) && $options['views_template_archive_for_' . $type] != 0)   {
							$post = get_post( $options['views_template_archive_for_' . $type] );
							if ( is_object($post) ){
								?>
								<a href="post.php?post=<?php echo $post->ID;?>&action=edit"><?php echo $post->post_title;?></a>
								<?php
							}
							else{
								echo $add_button;
							}
						}
						else{
						   echo $add_button;
						}
						?>
					</ul>
				</td>
				<td>
					<select class="js-list-ct-action">
						<option value="0"><?php _e('Choose','wpv-views') ?>&hellip;</option>
						<option value="change_pt" data-msg="1" data-sort="<?php echo $sort;?>" data-pt="<?php echo 'views_template_archive_for_' . $type;?>"><?php _e('Change Content Template','wpv-views') ?></option>
					</select>
				</td>

			</tr>
	<?php
		}
	}

	if ( $sort == 'usage-taxonomy-archives' ){

		for ($i=0;$i<count($post_types_array['taxonomy_post']);$i++){
			$type = $post_types_array['taxonomy_post'][$i][0];
			$label = $post_types_array['taxonomy_post'][$i][1];
			$add_button = '<a class="button" data-disabled="1"
						href="post-new.php?post_type=view-template&action=wpv_ct_create_new&post_title='. urlencode(__('Content template for ','wpv-views'). $label ) .'&ct_selected=views_template_loop_' . $type.'&toggle=0,0,1">
						<i class="icon-plus"></i>'. __('Add a new Content Template for this taxonomy','wpv-views').'</a>';
		?>

			<tr id="wpv_ct_list_row_<?php echo $type; ?>" class="js-wpv-ct-list-row">
				<td class="post-title page-title column-title">
					<h3 class="row-title">
						<?php echo $label;?>
					</h3>
				</td>
				<td>
					<ul>
						<?php
						if ( isset($options['views_template_loop_' . $type]) && $options['views_template_loop_' . $type] != 0)   {
							$post = get_post( $options['views_template_loop_' . $type] );
							if ( is_object($post) ){
								?>
								<a href="post.php?post=<?php echo $post->ID;?>&action=edit"><?php echo $post->post_title;?></a>
								<?php
							}
							else{
								 echo $add_button;
							}
						}
						else{
							echo $add_button;
						}
						?>
					</ul>
				</td>
				<td>
					<select class="js-list-ct-action">
						<option value="0"><?php _e('Choose','wpv-views') ?>&hellip;</option>
						<option value="change_pt" data-msg="2" data-sort="<?php echo $sort;?>" data-pt="<?php echo 'views_template_loop_' . $type;?>"><?php _e('Change Content Template','wpv-views') ?></option>
					</select>
				</td>

			</tr>
	<?php
		}
	}

	$row = ob_get_contents();
	ob_end_clean();

	return $row;
}